"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WormholeAptosBaseApi = void 0;
var WormholeAptosBaseApi = /** @class */ (function () {
    function WormholeAptosBaseApi(client) {
        var _this = this;
        // Contract upgrade
        this.authorizeUpgrade = function (senderAddress, vaa) {
            if (!_this.address)
                throw "Need bridge address.";
            var payload = {
                function: _this.address + "::contract_upgrade::submit_vaa",
                type_arguments: [],
                arguments: [vaa],
            };
            return _this.client.executeEntryFunction(senderAddress, payload);
        };
        this.upgradeContract = function (senderAddress, metadataSerialized, code) {
            if (!_this.address)
                throw "Need bridge address.";
            var payload = {
                function: _this.address + "::contract_upgrade::upgrade",
                type_arguments: [],
                arguments: [metadataSerialized, code],
            };
            return _this.client.executeEntryFunction(senderAddress, payload);
        };
        this.migrateContract = function (senderAddress) {
            if (!_this.address)
                throw "Need bridge address.";
            var payload = {
                function: _this.address + "::contract_upgrade::migrate",
                type_arguments: [],
                arguments: [],
            };
            return _this.client.executeEntryFunction(senderAddress, payload);
        };
        this.client = client;
    }
    return WormholeAptosBaseApi;
}());
exports.WormholeAptosBaseApi = WormholeAptosBaseApi;
