"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WormholeAptosApi = void 0;
var utils_1 = require("../../utils");
var client_1 = require("../client");
var coreBridge_1 = require("./coreBridge");
var tokenBridge_1 = require("./tokenBridge");
var WormholeAptosApi = /** @class */ (function () {
    function WormholeAptosApi(client, coreBridgeAddress, tokenBridgeAddress) {
        this.client = new client_1.AptosClientWrapper(client);
        this.coreBridge = new coreBridge_1.WormholeAptosCoreBridgeApi(this.client, coreBridgeAddress);
        this.tokenBridge = new tokenBridge_1.AptosTokenBridgeApi(this.client, tokenBridgeAddress);
    }
    WormholeAptosApi.fromNetwork = function (client, network) {
        return new WormholeAptosApi(client, utils_1.CONTRACTS[network].aptos.core, utils_1.CONTRACTS[network].aptos.token_bridge);
    };
    return WormholeAptosApi;
}());
exports.WormholeAptosApi = WormholeAptosApi;
