"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AptosTokenBridgeApi = void 0;
var utils_1 = require("../../utils");
var base_1 = require("./base");
var AptosTokenBridgeApi = /** @class */ (function (_super) {
    __extends(AptosTokenBridgeApi, _super);
    function AptosTokenBridgeApi(client, address) {
        var _this = _super.call(this, client) || this;
        // Attest token
        _this.attestToken = function (senderAddress, tokenChain, tokenAddress) {
            if (!_this.address)
                throw "Need token bridge address.";
            var assetType = utils_1.getAssetFullyQualifiedType(_this.address, utils_1.coalesceChainId(tokenChain), tokenAddress);
            if (!assetType)
                throw "Invalid asset address.";
            var payload = {
                function: _this.address + "::attest_token::attest_token_with_signer",
                type_arguments: [assetType],
                arguments: [],
            };
            return _this.client.executeEntryFunction(senderAddress, payload);
        };
        // Complete transfer
        _this.completeTransfer = function (senderAddress, tokenChain, tokenAddress, vaa, feeRecipient) {
            if (!_this.address)
                throw "Need token bridge address.";
            var assetType = utils_1.getAssetFullyQualifiedType(_this.address, utils_1.coalesceChainId(tokenChain), tokenAddress);
            if (!assetType)
                throw "Invalid asset address.";
            var payload = {
                function: _this.address + "::complete_transfer::submit_vaa",
                type_arguments: [assetType],
                arguments: [vaa, feeRecipient],
            };
            return _this.client.executeEntryFunction(senderAddress, payload);
        };
        _this.completeTransferWithPayload = function (_senderAddress, _tokenChain, _tokenAddress, _vaa) {
            throw new Error("Completing transfers with payload is not yet supported in the sdk");
        };
        // Deploy coin
        // don't need `signer` and `&signer` in argument list because the Move VM will inject them
        _this.deployCoin = function (senderAddress) {
            if (!_this.address)
                throw "Need token bridge address.";
            var payload = {
                function: _this.address + "::deploy_coin::deploy_coin",
                type_arguments: [],
                arguments: [],
            };
            return _this.client.executeEntryFunction(senderAddress, payload);
        };
        // Register chain
        _this.registerChain = function (senderAddress, vaa) {
            if (!_this.address)
                throw "Need token bridge address.";
            var payload = {
                function: _this.address + "::register_chain::submit_vaa",
                type_arguments: [],
                arguments: [vaa],
            };
            return _this.client.executeEntryFunction(senderAddress, payload);
        };
        // Transfer tokens
        _this.transferTokens = function (senderAddress, tokenChain, tokenAddress, amount, recipientChain, recipient, relayerFee, wormholeFee, nonce, payload) {
            if (payload === void 0) { payload = ""; }
            if (!_this.address)
                throw "Need token bridge address.";
            var assetType = utils_1.getAssetFullyQualifiedType(_this.address, utils_1.coalesceChainId(tokenChain), tokenAddress);
            if (!assetType)
                throw "Invalid asset address.";
            var entryFuncPayload;
            var recipientChainId = utils_1.coalesceChainId(recipientChain);
            if (payload) {
                throw new Error("Transfer with payload are not yet supported in the sdk");
            }
            else {
                entryFuncPayload = {
                    function: _this.address + "::transfer_tokens::transfer_tokens_with_signer",
                    type_arguments: [assetType],
                    arguments: [amount, recipientChainId, recipient, relayerFee, wormholeFee, nonce],
                };
            }
            return _this.client.executeEntryFunction(senderAddress, entryFuncPayload);
        };
        // Created wrapped coin
        _this.createWrappedCoin = function (senderAddress, tokenChain, tokenAddress, vaa) { return __awaiter(_this, void 0, void 0, function () {
            var createWrappedCoinTypePayload, assetType, createWrappedCoinPayload;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.address)
                            throw "Need token bridge address.";
                        createWrappedCoinTypePayload = {
                            function: this.address + "::wrapped::create_wrapped_coin_type",
                            type_arguments: [],
                            arguments: [vaa],
                        };
                        assetType = utils_1.getAssetFullyQualifiedType(this.address, utils_1.coalesceChainId(tokenChain), tokenAddress);
                        if (!assetType)
                            throw "Invalid asset address.";
                        return [4 /*yield*/, this.client.executeEntryFunction(senderAddress, createWrappedCoinTypePayload)];
                    case 1:
                        _a.sent();
                        createWrappedCoinPayload = {
                            function: this.address + "::wrapped::create_wrapped_coin",
                            type_arguments: [assetType],
                            arguments: [vaa],
                        };
                        return [2 /*return*/, this.client.executeEntryFunction(senderAddress, createWrappedCoinPayload)];
                }
            });
        }); };
        _this.address = address;
        return _this;
    }
    return AptosTokenBridgeApi;
}(base_1.WormholeAptosBaseApi));
exports.AptosTokenBridgeApi = AptosTokenBridgeApi;
