import { AptosAccount, AptosClient, Types, TxnBuilderTypes } from "aptos";
export declare class AptosClientWrapper {
    client: AptosClient;
    constructor(client: AptosClient);
    executeEntryFunction: (senderAddress: string, payload: Types.EntryFunctionPayload, opts?: Partial<{
        sender: string;
        sequence_number: string;
        max_gas_amount: string;
        gas_unit_price: string;
        expiration_timestamp_secs: string;
        payload: Types.TransactionPayload;
        signature: ({
            type: string;
        } & Types.Ed25519Signature) | ({
            type: string;
        } & {
            sender: ({
                type: string;
            } & Types.Ed25519Signature) | ({
                type: string;
            } & Types.MultiEd25519Signature);
            secondary_signer_addresses: string[];
            secondary_signers: (({
                type: string;
            } & Types.Ed25519Signature) | ({
                type: string;
            } & Types.MultiEd25519Signature))[];
        }) | ({
            type: string;
        } & Types.MultiEd25519Signature);
    }> | undefined) => Promise<TxnBuilderTypes.RawTransaction>;
}
export declare const signAndSubmitTransaction: (client: AptosClient, sender: AptosAccount, rawTx: TxnBuilderTypes.RawTransaction) => Promise<Types.UserTransaction>;
