import { CONTRACTS } from "../../utils";
import { AptosClientWrapper } from "../client";
import { WormholeAptosCoreBridgeApi } from "./coreBridge";
import { AptosTokenBridgeApi as WormholeAptosTokenBridgeApi } from "./tokenBridge";
var WormholeAptosApi = /** @class */ (function () {
    function WormholeAptosApi(client, coreBridgeAddress, tokenBridgeAddress) {
        this.client = new AptosClientWrapper(client);
        this.coreBridge = new WormholeAptosCoreBridgeApi(this.client, coreBridgeAddress);
        this.tokenBridge = new WormholeAptosTokenBridgeApi(this.client, tokenBridgeAddress);
    }
    WormholeAptosApi.fromNetwork = function (client, network) {
        return new WormholeAptosApi(client, CONTRACTS[network].aptos.core, CONTRACTS[network].aptos.token_bridge);
    };
    return WormholeAptosApi;
}());
export { WormholeAptosApi };
