import { TxnBuilderTypes } from "aptos";
import { ChainId, ChainName } from "../../utils";
import { AptosClientWrapper } from "../client";
import { WormholeAptosBaseApi } from "./base";
export declare class AptosTokenBridgeApi extends WormholeAptosBaseApi {
    constructor(client: AptosClientWrapper, address?: string);
    attestToken: (senderAddress: string, tokenChain: ChainId | ChainName, tokenAddress: string) => Promise<TxnBuilderTypes.RawTransaction>;
    completeTransfer: (senderAddress: string, tokenChain: ChainId | ChainName, tokenAddress: string, vaa: Uint8Array, feeRecipient: string) => Promise<TxnBuilderTypes.RawTransaction>;
    completeTransferWithPayload: (_senderAddress: string, _tokenChain: ChainId | ChainName, _tokenAddress: string, _vaa: Uint8Array) => Promise<TxnBuilderTypes.RawTransaction>;
    deployCoin: (senderAddress: string) => Promise<TxnBuilderTypes.RawTransaction>;
    registerChain: (senderAddress: string, vaa: Uint8Array) => Promise<TxnBuilderTypes.RawTransaction>;
    transferTokens: (senderAddress: string, tokenChain: ChainId | ChainName, tokenAddress: string, amount: number | bigint, recipientChain: ChainId | ChainName, recipient: Uint8Array, relayerFee: number | bigint, wormholeFee: number | bigint, nonce: number | bigint, payload?: string) => Promise<TxnBuilderTypes.RawTransaction>;
    createWrappedCoin: (senderAddress: string, tokenChain: ChainId | ChainName, tokenAddress: string, vaa: Uint8Array) => Promise<TxnBuilderTypes.RawTransaction>;
}
